<?php
/**
 * @package zpayment payment module
 *
 * @package paymentMethod
 * @copyright Copyright 2003-2014 Z-Payment
 */

	class zpayment {
		var $code, $title, $description, $enabled;
		var $params = array('unit_id' => '', 'limit_ids' => '', 'account_id' => '', 'online' => 1);

		// class constructor
		function zpayment() {
			global $order;

			$this->code = 'zpayment';
			$this->title = MODULE_PAYMENT_ZPAYMENT_TEXT_TITLE;
			$this->description = MODULE_PAYMENT_ZPAYMENT_TEXT_DESCRIPTION;
			$this->sort_order = MODULE_PAYMENT_ZPAYMENT_SORT_ORDER;
			$this->enabled =	((MODULE_PAYMENT_ZPAYMENT_STATUS == 'True') ? true : false);

			if ((int)MODULE_PAYMENT_ZPAYMENT_PREPARE_ORDER_STATUS_ID > 0) {
				$this->order_status = MODULE_PAYMENT_ZPAYMENT_PREPARE_ORDER_STATUS_ID;
			}

			if (is_object($order)) $this->update_status();
		}

		// class methods
		function update_status() {
			global $order, $db;

			if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_ZPAYMENT_ZONE > 0) ) {
				$check_flag = false;
				$check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_ZPAYMENT_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
				while ($check = $check_query->fields) {
					if ($check['zone_id'] < 1) {
						$check_flag = true;
						break;
					} elseif ($check['zone_id'] == $order->billing['zone_id']) {
						$check_flag = true;
						break;
					}
				}

				if ($check_flag == false) {
					$this->enabled = false;
				}
			}
		}

		function javascript_validation() {
			return false;
		}
		
		function selection() {
			return array('id' => $this->code, 'module' => $this->title);
		}

		function pre_confirmation_check() {
			return false;
		}

		function confirmation() {
			return false;
		}

		function process_button() {
			return false;
		}

		function before_process() {
			return false;
		}

		function after_process() {
			global $insert_id, $currencies, $order, $db, $cart;
			
			/*switch (MODULE_PAYMENT_ZPAYMENT_TEST_MODE) {
				case 'Real':
					$test_mode = '0';
					break;
				case 'Test':
					$test_mode = '1';
					break;
			}*/
			
			$lang_query = $db->Execute("select code from " . TABLE_LANGUAGES . " where languages_id = '" . (int)$languages_id . "'");
			$lang = $lang_query->fields; 
			
			switch (strtolower($lang['code'])) {
				case 'en':
				case 'ru':
					$language_code = strtolower($lang['code']);
					break;
				default:
					$language_code = strtolower(DEFAULT_LANGUAGE);
			}
			
//			$transactionId = STORE_NAME . date('Ymdhis') . rand (0, 99999);
			$amount = number_format($order->info['total'] , 2, '.', '');
			//$amount = number_format($order->info['total'] * $currencies->get_value(MODULE_PAYMENT_ZPAYMENT_CURRENCY_CODE), 2, '.', '');
			$order_id = $insert_id;
			/*$currency = ('RUR' == MODULE_PAYMENT_ZPAYMENT_CURRENCY_CODE) ? 'RUB' : MODULE_PAYMENT_ZPAYMENT_CURRENCY_CODE;
			if ($this->params['online']) {
				$action = 'https://' . MODULE_PAYMENT_ZPAYMENT_SERVER . '/assistant.htm?';
			} else {
				$action = zen_href_link('zpayment_invoice');
			}*/
			
			
			$currency = 'RUB';
			$action = 'https://z-payment.com/merchant.php?';
			$_SESSION['cart']->reset(true);
			unset($_SESSION['sendto']);
			unset($_SESSION['billto']);
			unset($_SESSION['shipping']);
			unset($_SESSION['payment']);
			unset($_SESSION['comments']);
			
			$order_query = $db->Execute("select * from " . TABLE_ORDERS . " where orders_id = '" . (int)$order_id . "'");
		    $orderi = $order_query->fields;
			$email = $orderi['customers_email_address'];

			zen_redirect( $action .
								'&LMI_PAYEE_PURSE=' . MODULE_PAYMENT_ZPAYMENT_SHOP_ID .
								'&LMI_PAYMENT_NO=' . $order_id . 
								'&LMI_PAYMENT_AMOUNT=' . $amount .
								'&LMI_PAYMENT_DESC=' . 'payment NO ' . $order_id . 
								'&CLIENT_MAIL=' . $email .
								'&ZP_SIGN=' . md5(MODULE_PAYMENT_ZPAYMENT_SHOP_ID .$order_id . $amount . MODULE_PAYMENT_ZPAYMENT_INITIALIZATION_PASSWORD) );
		}
		
		function output_error() {
			return false;
		}

		function check() {
			global $db;

			if (!isset($this->_check)) {
				$check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_ZPAYMENT_STATUS'");
				$this->_check = $check_query->RecordCount();
			}
			return $this->_check;
		}

		function install() {
			global $db;

			$check_query = $db->Execute("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Preparing [Z-Payment]' limit 1");

			if ($check_query->RecordCount() < 1) {
				$status_query = $db->Execute("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
				$status = $status_query->fields;

				$status_id = $status['status_id']+1;

				$languages = zen_get_languages();

				for ($i=0, $n=sizeof($languages); $i<$n; $i++) {
					$db->Execute("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '" . $languages[$i]['id'] . "', 'Preparing [Z-Payment]')");
				}

				$flags_query = $db->Execute("describe " . TABLE_ORDERS_STATUS . " public_flag");
				if ($flags_query->RecordCount() == 1) {
					$db->Execute("update " . TABLE_ORDERS_STATUS . " set public_flag = 1 and downloads_flag = 0 where orders_status_id = '" . $status_id . "'");
				}
			} else {
				$check = $check_query->fields;

				$status_id = $check['orders_status_id'];
			} 
		
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Z-Payment Module', 'MODULE_PAYMENT_ZPAYMENT_STATUS', 'True', 'Do you want to accept Z-Payment payments?', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Shop ID', 'MODULE_PAYMENT_ZPAYMENT_SHOP_ID', '', 'Shop ID in Z-Payment system. ', '6', '3', now())");
			
			/*$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Currency Code', 'MODULE_PAYMENT_ZPAYMENT_CURRENCY_CODE', 'RUR', 'ISO currency code which is used for payment of the order. The currency code must correspond to the currency of the recipient account (Merchant ID)', '6', '4', 'zen_cfg_select_option(array(\'RUR\', \'EUR\', \'USD\', \'GBP\'), ', now())");*/
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant Key', 'MODULE_PAYMENT_ZPAYMENT_MERCHANT_KEY', '', '', '6', '4', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Initialization Password', 'MODULE_PAYMENT_ZPAYMENT_INITIALIZATION_PASSWORD', '', '', '6', '5', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Acknowledged Order Status', 'MODULE_PAYMENT_ZPAYMENT_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '8', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_ZPAYMENT_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first', '6', '9', now())");
		}

		function remove() {
			global $db;
			$db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
		}

		function keys() {
			return array('MODULE_PAYMENT_ZPAYMENT_STATUS', 'MODULE_PAYMENT_ZPAYMENT_SHOP_ID', 'MODULE_PAYMENT_ZPAYMENT_INITIALIZATION_PASSWORD', 'MODULE_PAYMENT_ZPAYMENT_MERCHANT_KEY',  'MODULE_PAYMENT_ZPAYMENT_PREPARE_ORDER_STATUS_ID', 'MODULE_PAYMENT_ZPAYMENT_ORDER_STATUS_ID', 'MODULE_PAYMENT_ZPAYMENT_SORT_ORDER');
		}
	}
?>